// mfcdt10.cpp: Implements the exported functions
//

// If you're compiling this using VC++5 you must define STRICT.
// If you're using VC++6 it works without this define, so
// obviously Microsoft changed the header files to define it
// for you.  For more info see the following article in the MSDN:
//   TN012: Using MFC with Windows 3.1 Robustness Features

/** 
 * Note that you must include "basetsd.h from VC++ in your project 
 * otherwise you will get warning like inconsistenct linkage.
 */
#ifndef STRICT
#define STRICT 1
#endif


//#if !defined (_MSC_VER)
//#include <windows.h>
//#else
#include "stdafx.h"
//#endif
/**
 * Note: 
 * 
 * Cannot include windows.h if we use MFC. And we must include "stdafx.h",
 * when using MFC, in every file to force the correct order of the libraries.
 * If the correct link order is not enforced, we will get something like
 *  
 *   error LNK2005: _DllMain@12 already defined in MSVCRTD.lib(dllmain.obj)
 * 
 * See MS KowledgeBase Q148652 at 
 * 
 *   http://support.microsoft.com/default.aspx?scid=KB;en-us;q148652
 */

#include <tchar.h>
#include <crtdbg.h>
#include <string.h>
#include <stdlib.h>
#include <lmcons.h>
#include <lmapibuf.h>
#include <lmaccess.h>
#include <lm.h>
#include <winsock2.h>

  

#ifndef DITINGHK_EXPORTS
#define DITINGHK_EXPORTS
#endif

/** 
 * In this dll the exported functions should have __declspec(dllexport)
 * linkage. In other code that calls these functions, the linkage should be
 * __declspec(dllimport). This switch is achieved by defining/undefining
 * DITINGHK_EXPORTS. We must define the macro before #include "mfcdt10.h".
 * See mfcdt10.h.
 */


#include "mfcdt10.h"
#include "IPC.h"
#include "msword9.h"
#include "excel9.h"
#include "msppt9.h"
#include "msacc9.h"

#include "iostream.h"
#include "fstream.h"

#ifdef __cplusplus
extern "C" {
#endif

// Global variables
static HHOOK g_hHook = NULL;				// Handle to the hook
static DWORD g_dwThreadId = 0;				// Hooked thread
static HINSTANCE g_hinstDLL = NULL;			// Handle to this DLL
static CIPC g_obIPC;						// Shared resources used to transfer 
											// data from Spy to the hook code
static HWND g_spyWnd = NULL;				// Handle to the Spy window
static CIPC g_hWndIPC;						// Shared resources used to transfer data from 
											// Spy to the hook code. This holds Spy's HWND

// Use a shared section to store these variables so they are accessible 
// to all instance of this DLL.
#pragma data_seg("Shared")
static AppInfo g_registeredApps[MAX_REGISTERED_APPS] = { _T('\0'), _T('\0'), false };
static int g_nRegisteredApps = 0;

// Socket shared across all processes that get DITING mapped into it
static SOCKET sock = 0;                // Socket to be shared
static DWORD srcProcessId = 0;         // The process that creates it
static HANDLE srcProcessHandle = 0;    // The process that creates it
static BOOL useSocket = FALSE;
#pragma data_seg()
#pragma comment(linker, "/section:Shared,rws")
/**
 * Note that static global variables in a DLL are not shared among all instances
 * of the DLL. Each address space has its own instances of these variables. To share 
 * amoung them, create a new section and put the shared variables into that section. 
 * The system doesn't create new instances for variables in user defined sections.
 * However, you must initialize them otherwise the compiler will put them in .bss
 * section. In addition, you need to use 
 *
 *     #pragma comment(linker, "/section:Shared,rws")
 *
 * to tell linker about them.
 */

#ifdef _DEBUG
#define _DTDLL_LOG
#endif

#ifdef _DTDLL_LOG
const char * dlllogfilename = "e:\\research\\abc\\logging\\dllout.txt";
ofstream g_dlloutFile;
#endif

/** 
 * We use absolute path here because this DLL will be mapped into the 
 * address space of all applications, each of which may have different path.
 * This may result in the debug file scattered at all places. Modify this
 * if you code in a different system.
 */

// Macros for writing to the debug log file
#ifdef _DTDLL_LOG 

#define DT_DEBUG_OPEN();  \
	if(!g_dlloutFile.is_open())	\
		g_dlloutFile.open(dlllogfilename, ios::app); 

#define DT_DEBUG_CLOSE(); \
	g_dlloutFile.close();

// The DT_DEBUG_PRINT* macros. You can print up to 4 messages, in the order
// they are passed without any delimiters between them. You can use the messages 
// in the middle as dilimiters. DT_DEBUG_PRINTLN will add an endl to the end of 
// the line. The messages don't have to be char strings. They can be numbers.

#define DT_DEBUG_PRINT(msg); \
	g_dlloutFile<<msg;

#define DT_DEBUG_PRINTLN(msg); \
	g_dlloutFile<<msg<<endl;

#define DT_DEBUG_PRINT2(msg1, msg2); \
	g_dlloutFile<<msg1<<msg2;

#define DT_DEBUG_PRINTLN2(msg1, msg2); \
	g_dlloutFile<<msg1<<msg2<<endl;

#define DT_DEBUG_PRINT3(msg1, msg2, msg3); \
	g_dlloutFile<<msg1<<msg2<<msg3;

#define DT_DEBUG_PRINTLN3(msg1, msg2, msg3); \
	g_dlloutFile<<msg1<<msg2<<msg3<<endl;

#define DT_DEBUG_PRINT4(msg1, msg2, msg3, msg4); \
	g_dlloutFile<<msg1<<msg2<<msg3<<msg4;

#define DT_DEBUG_PRINTLN4(msg1, msg2, msg3, msg4); \
	g_dlloutFile<<msg1<<msg2<<msg3<<msg4<<endl;

#else

#define DT_DEBUG_OPEN();
#define DT_DEBUG_CLOSE();
#define DT_DEBUG_PRINT(msg); 
#define DT_DEBUG_PRINTLN(msg);
#define DT_DEBUG_PRINT2(msg1, msg2);
#define DT_DEBUG_PRINTLN2(msg1, msg2); 
#define DT_DEBUG_PRINT3(msg1, msg2, msg3); 
#define DT_DEBUG_PRINT3(msg1, msg2, msg3); 
#define DT_DEBUG_PRINT4(msg1, msg2, msg3, msg4); 
#define DT_DEBUG_PRINTLN4(msg1, msg2, msg3, msg4); 

#endif 


const char * hostname = "localhost";
const unsigned short port = 9494;
const char ETX = (char)0x8f; 

/**
 * Initialize the shared global variables. This function is called from
 * the Spy. This step is necassary because these variable may retain their
 * values across multiple invokations of Spy.
 */
void WINAPI InitializeDiTingDLL() {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    g_hinstDLL = GetModuleHandle(DITING_HOOK_DLL);
    // Get handle to the mfcditing.dll. This is needed by SetWindowsHookEx.
    // Note that calling GetModuleHandle(NULL); will return a handle to the 
    // file used to create the calling process. This is not what is needed
    // in SetWindowsHookEx.

    // We can only get the handle like this since we don't have DllMain when
    // we use MFC.


	// This call disables the DLL_THREAD_ATTACH and DLL_THREAD_DETACH
	// messages.  DllMain should not get called with those messages.
	DisableThreadLibraryCalls(g_hinstDLL);
	g_nRegisteredApps = 0;
}

/**
 * This function is called from Spy only.
 */

bool WINAPI RemoveHook(void) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	bool bSuccess = false;

	try	{
		if(g_hHook != NULL)	{
			bSuccess = UnhookWindowsHookEx(g_hHook) ? true : false;
			g_hHook = NULL;
			g_dwThreadId = 0;
		}
	}
	catch(...) {}

    if(useSocket && srcProcessId == GetCurrentProcessId()) 
        // This must be the process that creates this socket
        closesocket(sock);

	return bSuccess;
}


/**
 * This function is called from Spy only. It registers an application that 
 * will be watched. The return value is the an ID that can be used to
 * reference the application. Under the hood, it is the index into the 
 * registered application table. It will be returned with COPYDATASTRUCT.
 */

int WINAPI RegisterApp(const TCHAR * cmd, bool needURL) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());

	DT_DEBUG_OPEN();
	DT_DEBUG_PRINTLN4("RegisterApp called with cmd: ", cmd, ", needURL: ", needURL);
	DT_DEBUG_PRINTLN2("\tCurrently g_nRegisteredApps = ", g_nRegisteredApps);

	if(g_nRegisteredApps >= MAX_REGISTERED_APPS) {
		DT_DEBUG_PRINTLN("Too many registered apps!"); 
		DT_DEBUG_CLOSE();
		return -1;
	}

	TCHAR szCmd[MAX_PATH] = {_T('\0')};
	
	/**
	 * For some applications, e.g. notepad, the string returned by
	 * GetCommandLine() are mot enclosed by quotion marks. To make the 
	 * subsequent processing consistent, lets add them here. Quotion marks
	 * are necessary because Windows path name can have space which will
	 * make arguments confusing.
	 */
	if(cmd[0] != '\"') 
		wsprintf(szCmd, _T("\"%s\""), cmd);
	else
		wsprintf(szCmd, _T("%s"), cmd);

	if(IsRegistered(szCmd) >= 0) {
		DT_DEBUG_CLOSE();
		return -1;
	}

	lstrcpy(g_registeredApps[g_nRegisteredApps].cmd, szCmd);
	g_registeredApps[g_nRegisteredApps].needURL = needURL;
	g_nRegisteredApps++;
	
	DT_DEBUG_CLOSE();
	return g_nRegisteredApps-1;
}


bool WINAPI UnRegisterApp(const TCHAR * cmd) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	return TRUE;

	// Not supporting it.
}

/**
 * On success, returns the index into the registered application table 
 * where this application is stored. -1 if not found.
 */

int IsRegistered(const TCHAR * cmd) {
//    AFX_MANAGE_STATE(AfxGetStaticModuleState());
    TCHAR buf[1024];
    TCHAR * p;


	DT_DEBUG_OPEN();
	DT_DEBUG_PRINTLN2("IsRegisteed called with:", cmd);
	DT_DEBUG_PRINTLN2("g_nRegisteredApps      :", g_nRegisteredApps);

    // Retrieve the sub string before the 2nd " (the rest could be switches 
    // and arguments).
    CopyMemory(buf, cmd, lstrlen(cmd));
    p = strchr(buf+1, '\"');  // Note that the first char is ". We need to start from the 2nd.
    if(p != NULL)
        *(p+1) = '\0';
    else
        buf[lstrlen(cmd)] = '\0';

	for(int i = 0; i < g_nRegisteredApps; i++) {
		DT_DEBUG_PRINTLN2("Registered :", g_registeredApps[i].cmd);
		DT_DEBUG_PRINTLN2("Seen       :", buf);

  //	int len = lstrlen(g_registeredApps[i].cmd);
       	int len = lstrlen(buf) - 1;
        // buf could be shorter than g_registeredApps[i].cmd. It could be
        // without .exe or .com. Also the last char should be " and should
        // be excluded (hence the - 1)


		// Note we use the length of the registered string for comparison 
		// because the command string passed to us may contain arguments and
		// could be longer.
		if(CompareString(LOCALE_SYSTEM_DEFAULT,NORM_IGNORECASE, 
			g_registeredApps[i].cmd, len, buf, len) == CSTR_EQUAL) {

            DT_DEBUG_PRINTLN4("Found match !!!!! This guy's needURL is: ", 
				g_registeredApps[i].needURL, " returning ", i);;
			DT_DEBUG_CLOSE();

			return i;
		}
	}
	

	DT_DEBUG_CLOSE();

	return -1;
}

/**
 * Some global bariables for passing windows text from EnumChildProc
 */

static TCHAR g_szText[1024] = {_T('\0')};  
// Global variable to hold all child windows' text
static TCHAR g_szURL[1024] = {_T('\0')};  
// Global variable to pass URL
static int curPos = 0;
// Pointer to the current position in the above buffer.
const static TCHAR DELIMITER = _T('$');


BOOL IsURL(const TCHAR * str) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	if( strstr(str, "://") != NULL || strstr(str, "www.") != NULL 
		|| strstr(str, ".com") != NULL || strstr(str, ".org") != NULL 
		|| strstr(str, ".edu") != NULL || strstr(str, ".mil") != NULL 
		|| strstr(str, ":\\") != NULL || strstr(str, ":/") != NULL )  
		// maybe viewing local docs.
		return TRUE;
	return FALSE;
}


// Function to enumerate a window's all child windows and retrieve
// useful text if appropriate.
BOOL CALLBACK EnumChildProc(HWND hWnd, LPARAM lParam) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	TCHAR szWndClass[128] = {_T('\0')};  
	int cnt;
	
	if(GetClassName(hWnd, szWndClass, sizeof(szWndClass)/sizeof(TCHAR))) {
		// Only check edit boxes. And these are all I can think of:
		if( wcscmp((const wchar_t *)szWndClass, (const wchar_t *)_T("edit")) != 0 
			&& wcscmp((const wchar_t *)szWndClass, (const wchar_t *)_T("Edit")) != 0
			&& wcscmp((const wchar_t *)szWndClass, (const wchar_t *)_T("EDIT")) != 0 )
			return TRUE;
	}

	cnt = GetWindowText(hWnd, (LPTSTR)&g_szText[curPos], 256);
	if(IsURL((TCHAR*)&g_szText[curPos])) {
		lstrcpy(g_szURL, (LPTSTR)&g_szText[curPos]); 
		return FALSE;  // Don't need to enumerate anymore
	}
	
	// Write a separator:
	curPos += cnt;
	g_szText[curPos++] = DELIMITER;

	return TRUE;
}


/**
 * Helper function used by DITING to create connection to the logger
 * using a socket. This socket will be shared across all processes
 * that map DITING into their address space.
 */

BOOL CreateSocket(const char * servername, const unsigned short portno) {
	PHOSTENT phe;
	char szTemp[200];
	SOCKADDR_IN dest_sin;  /* DESTination Socket INternet */
	dest_sin.sin_family = AF_INET;
    WORD wVersionRequested;
    WSADATA wsaData;
    int err;
 
    // Must call WSAStartup before any socket calls
    // Request version 2.2 of Windows Sockets
    wVersionRequested = MAKEWORD(2, 2);
    err = WSAStartup(wVersionRequested, &wsaData);
    if(err != 0) {
        /* Tell the user that we could not find a usable */
        /* WinSock DLL.                                  */
        return FALSE;
    }
 
    /* Confirm that the WinSock DLL supports 2.2.*/
    /* Note that if the DLL supports versions greater    */
    /* than 2.2 in addition to 2.2, it will still return */
    /* 2.2 in wVersion since that is the version we      */
    /* requested.                                        */
    if(LOBYTE(wsaData.wVersion) != 2 ||
        HIBYTE(wsaData.wVersion ) != 2) {
        /* Tell the user that we could not find a usable */
        /* WinSock DLL.                                  */
        WSACleanup( );
        return FALSE; 
    } 

	sock = socket(AF_INET, SOCK_STREAM, 0);
    if (sock == INVALID_SOCKET) {
        int errorcode = WSAGetLastError(); 

        switch(errorcode) {
        case WSANOTINITIALISED:  // A successful WSAStartup must occur before using this function. 
            sprintf(szTemp, "WSAStartup must be called");
            break;
        case WSAENETDOWN: //The network subsystem or the associated service provider has failed. 
            sprintf(szTemp, "network subsystem failed");
            break;
        case WSAEAFNOSUPPORT: // The specified address family is not supported. 
            sprintf(szTemp, "address family is not supported.");
            break;
        case WSAEINPROGRESS: //A blocking Windows Sockets 1.1 call is in progress, 
            // or the service provider is still processing a callback function. 
            sprintf(szTemp, "Another call is in progress,");
            break;
        case WSAEMFILE: // No more socket descriptors are available. 
            sprintf(szTemp, "No more socket descriptors are available");
            break;
        case WSAENOBUFS: // No buffer space is available. The socket cannot be created. 
            sprintf(szTemp, "No buffer space is available");
            break;
        case WSAEPROTONOSUPPORT: // The specified protocol is not supported. 
            sprintf(szTemp, "Protocol is not supported.");
            break;
        case WSAEPROTOTYPE: // The specified protocol is the wrong type for this socket. 
            sprintf(szTemp, "The specified protocol is the wrong type for this socket");
            break;
        case WSAESOCKTNOSUPPORT: // The specified socket type is not supported in this address family.
            sprintf(szTemp, "The specified socket type is not supported in this address family");
            break;
        default:
            sprintf(szTemp, "Unknown error.");
            break;
        }

   		//MessageBox(NULL, szTemp, "socket() failed.", MB_OK);
        return FALSE;
    }

	BOOL optval = TRUE;
	
	err = setsockopt(sock, IPPROTO_TCP, TCP_NODELAY, 
        (const char *)&optval, sizeof(optval));
	// Disables the Nagle algorithm for send coalescing so data will be send immeidately.


    // Retrieve the IP address and TCP Port number. Variable servername contains 
    // the remote host name.
	phe = gethostbyname(servername);

	if (phe == NULL) {
		sprintf(szTemp, "%d is the error. Make sure '%s' is listed in the hosts file.", 
            WSAGetLastError(), servername);
		//MessageBox(NULL, szTemp, "gethostbyname() failed.", MB_OK);
        closesocket( sock );
		return FALSE;
	}
	memcpy((char FAR *)&(dest_sin.sin_addr), phe->h_addr, phe->h_length);

	dest_sin.sin_port = htons(portno);        /* Convert to network ordering */

	if (connect(sock, (PSOCKADDR) &dest_sin, sizeof( dest_sin)) < 0) {
		closesocket(sock);
		//MessageBox(NULL, "connect() failed", "Error", MB_OK);
		return FALSE;
	}

    // Save the creating process's handle so that it can be used by other
    // process to duplicate the socket handle:
    srcProcessId = GetCurrentProcessId();
    srcProcessHandle = OpenProcess(
                PROCESS_ALL_ACCESS,     // access flag
                FALSE,                  // handle inheritance flag
                srcProcessId            // process identifier
            );

    /**
     * Note that cannot use GetCurrentProcess because it return a pseudohandle 
     * that is only valid in the current process. OpenProcess returns a "real" handle
     */
    //MessageBox(NULL, "connect() successful", "OK", MB_OK);
    useSocket = TRUE;

   	if(send(sock, "hello", lstrlen ("hello"), 0 ) == SOCKET_ERROR) {
		wsprintf(szTemp, "WSAGetLastError: %d", WSAGetLastError());
        //MessageBox(NULL, szTemp, "Error on send()", MB_OK);
        closesocket(sock);
    }
 
	return TRUE;
}


/**
 * Helper function within this DLL. It returns the full name of a 
 * user given in UserName. If Domain is not NULL, the fuction will
 * lookup the computer name of the domain controller and retrieve 
 * the info from the DC. If Domain is NULL, it will ask the local 
 * machine, which will return the full name of the user on the local
 * system.
 */

BOOL GetFullName(char *UserName, char *Domain, char *dest ) {
    WCHAR wszUserName[UNLEN+1];          // Unicode user name
    WCHAR wszDomain[256]; 
    LPBYTE ComputerName;
    NET_API_STATUS nStatus;
	char buf[256];

//    struct _SERVER_INFO_100 *si100;  // Server structure
    struct _USER_INFO_2 *ui;         // User structure

    // Convert ANSI user name and domain to Unicode
    MultiByteToWideChar( CP_ACP, 0, UserName,
        strlen(UserName)+1, wszUserName,   
     sizeof(wszUserName)/sizeof(wszUserName[0]) );
    if(Domain != NULL) {
        MultiByteToWideChar( CP_ACP, 0, Domain,
            strlen(Domain)+1, wszDomain, sizeof(wszDomain)/sizeof(wszDomain[0]) );
        // Get the computer name of a DC for the domain.
        if( NetGetDCName( NULL, wszDomain, &ComputerName ) != NERR_Success)
            goto DONE;

        // Look up the user on the DC.
        if( (nStatus = NetUserGetInfo( (LPWSTR) ComputerName,
            (LPWSTR) &wszUserName, 2, (LPBYTE *) &ui )) != NERR_Success) 
            goto DONE;
    }
    else {  // We are not in a domain, check with local computer
        if( (nStatus = NetUserGetInfo( (LPWSTR) NULL,
            (LPWSTR) &wszUserName, 2, (LPBYTE *) &ui )) != NERR_Success)
            goto DONE;
    }

DONE:
    if(nStatus == NERR_Success) {
        NetApiBufferFree(ui);
        // Memory returned by Net functions must be freed this way.

        // Convert the Unicode full name to ANSI.
        WideCharToMultiByte( CP_ACP, 0, ui->usri2_full_name, -1,
            buf, 256, NULL, NULL );
		// Add quote to the user name:
		sprintf(dest, "\"%s\"", buf);
        return (TRUE);
    }

    else if(nStatus == ERROR_ACCESS_DENIED) 
        sprintf(dest, "\"Access Denied\"");
    else if(nStatus == NERR_InvalidComputer)
        sprintf(dest, "\"Invalid Computer\"");
    else if(nStatus == NERR_UserNotFound)
        sprintf(dest, "\"User not found\"");

    return FALSE;
}


/**
 * This function is called from the HOOKED process only
 */


/**
 * Note: 
 * 
 * GetActiveObject succeeds only when the application starts with /Automation switch 
 * (e.g. winword /automation). See MSDN:
 *
 *      When an application is started with the /Automation switch, it should 
 *      initialize its Application object as the active object by calling 
 *      RegisterActiveObject after it initializes OLE.
 */

LRESULT WINAPI CBTProc(int nCode, WPARAM wParam, LPARAM lParam){
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	TCHAR szBuf[MAX_PATH*4] = {_T('\0')};
    TCHAR szCode[64] = {_T('\0')}; 
	TCHAR szDir[MAX_PATH] = {_T('\0')};
	TCHAR szCmd[MAX_PATH] = {_T('\0')};
	TCHAR szCaption[MAX_PATH] = {_T('\0')};
    int cch; 
	static int c = 0;
	HWND hThisWnd = NULL;		// Handle to this window
	int appID = 0;
	bool officeAutomationFailed = false;

    if (nCode < 0)  // do not process message 
        return CallNextHookEx(g_hHook, nCode, wParam, lParam); 


    switch (nCode)  { 
        case HCBT_ACTIVATE: 
			hThisWnd = (HWND)wParam;
            lstrcpy(szCode, _T("HCBT_ACTIVATE")); 
            break; 
        case HCBT_DESTROYWND: 
			hThisWnd = (HWND)wParam;
            lstrcpy(szCode, _T("HCBT_DESTROYWND")); 
            break; 
        case HCBT_SETFOCUS: 
            lstrcpy(szCode, _T("HCBT_SETFOCUS")); 
			hThisWnd = (HWND)wParam;
            break; 

		// We skip the following events (by not setting hThisWnd):
        case HCBT_CLICKSKIPPED: 
			lstrcpy(szCode, _T("HCBT_CLICKSKIPPED"));
			break;
        case HCBT_CREATEWND: 
//			hThisWnd = (HWND)wParam;
            lstrcpy(szCode, _T("HCBT_CREATEWND")); 
			break;
        case HCBT_KEYSKIPPED: 
            lstrcpy(szCode, _T("HCBT_KEYSKIPPED")); 
			break;
        case HCBT_MINMAX: 
            lstrcpy(szCode, _T("HCBT_MINMAX")); 
			break;
        case HCBT_MOVESIZE: 
            lstrcpy(szCode, _T("HCBT_MOVESIZE")); 
			break;
        case HCBT_QS: 
            lstrcpy(szCode, _T("HCBT_QS")); 
			break;
        case HCBT_SYSCOMMAND: 
            lstrcpy(szCode, _T("HCBT_SYSCOMMAND")); 
			break;
        default: 
            lstrcpy(szCode, _T("Unknown")); 
			break;
    } 

	/**
	 * Note that we are only interested in the first 3 events. In particular,
	 * we don't intercept HCBT_CREATEWND here because the document path may not
	 * be available yet. Intercepting it may cause problems for MS office apps.
	 */ 

	DT_DEBUG_OPEN();
	DT_DEBUG_PRINTLN2("CBTProc called with code ", szCode);

	if(hThisWnd == NULL) {
		DT_DEBUG_CLOSE();
        return CallNextHookEx(g_hHook, nCode, wParam, lParam); 
	}

    // Now this is something we should process.
	wsprintf(szDir, _T("%s"), GetCommandLine());
	
	// For some applications, e.g. notepad, the string returned by
	// GetCommandLine() are not enclosed by quotation marks. To make the 
	// subsequent processing consistent, lets add them here. Quotion marks
	// are necessary because Windows path name can have space which will
	// make arguments confusing.

	while(szDir[strlen(szDir)-1] == ' ')
		szDir[strlen(szDir)-1] = '\0';   // Trim the trailing which space/

	if(szDir[0] != '\"') {
		// We assume the first space separetes command and arguments
		TCHAR *p = strchr(szDir, ' ');
		if(p != NULL) {
			if(lstrlen(p) > 1) {
				*p = '\0';
				wsprintf(szCmd, _T("\"%s\" \"%s\""), szDir, p+1);
			}
			else
				wsprintf(szCmd, _T("\"%s\""), szDir);
		}
		else
			wsprintf(szCmd, _T("\"%s\""), szDir);
	}
	else
		wsprintf(szCmd, _T("%s"), szDir);

	DT_DEBUG_PRINTLN4("\tCmd: ", szCmd, ", GetCommandLine returned: ", szDir);

	if(g_hHook == NULL)	{	// Read the data from the shared resources
		DWORD dwData = 0, dwSize = sizeof(dwData);
		g_obIPC.Lock();
		g_obIPC.OpenIPCMMF();
		g_obIPC.ReadIPCMMF((LPBYTE)&dwData, dwSize);
		g_obIPC.Unlock();

		g_hHook = (HHOOK)dwData;
	}

	if(g_spyWnd == NULL) {	// Read the data from the shared resources
		DWORD dwData = 0, dwSize = sizeof(dwData);
		g_hWndIPC.Lock();
		g_hWndIPC.OpenIPCMMF();
		g_hWndIPC.ReadIPCMMF((LPBYTE)&dwData, dwSize);
		g_hWndIPC.Unlock();
		g_spyWnd = (HWND)dwData;
	}


    // Get user of the running process
    TCHAR szUserName[UNLEN + 1] = {_T('\0')};
    DWORD nSize = UNLEN + 1;
    // Get the user login name:
    GetUserName(szUserName, &nSize);
    // Get the user full name:
    GetFullName(szUserName, NULL, szUserName);
  
	
	DT_DEBUG_PRINT("\tNow calling IsRegistered ...");
	appID = IsRegistered(szCmd);
	DT_DEBUG_PRINTLN2("done. returned: ", appID);

    if(appID < 0) {
		DT_DEBUG_PRINTLN2("\tNot registered! IsRegistered returned: ", appID);
		DT_DEBUG_CLOSE();

   		COPYDATASTRUCT cds = {0};
		cds.dwData = (DWORD)ID_NOTREGISTERED;
		cds.cbData = 0;
		cds.lpData = NULL;
        //MessageBeep(0xFFFFFFFF);   // Beep
		SendMessage(g_spyWnd, WM_COPYDATA, (WPARAM)hThisWnd, (LPARAM)&cds);
		return CallNextHookEx(g_hHook, nCode, wParam, lParam); 

    }
 
	// See if it is one of the office apps:
	enum { 
		NON_OFFICE, 
		WINWORD, 
		EXCEL, 
		MSACCESS, 
		POWERPNT, 
		OUTLOOK 
	};

	int thisApp = NON_OFFICE;


    if(strstr(_strlwr(szDir), "word"))
		thisApp = WINWORD;
	else if(strstr(szDir, "excel")) 
		thisApp = EXCEL;
	else if (strstr(szDir, "msaccess"))
		thisApp = MSACCESS;
	else if (strstr(szDir, "powerp"))
		thisApp = POWERPNT;
	else if (strstr(szDir, "outlook"))
		thisApp = OUTLOOK;

	if(thisApp != NON_OFFICE) {	// Use automation to talk to office apps:
		CString fullName;
		LPDISPATCH pDisp;
		LPUNKNOWN pUnk;
		CLSID clsid;
		HRESULT hrst;
		COleDispatchDriver theApplication;


		switch(thisApp) {
		case WINWORD:
			hrst = ::CLSIDFromProgID(L"Word.Application", &clsid);
			break;
		case EXCEL:
			hrst = ::CLSIDFromProgID(L"Excel.Application", &clsid);
			break;
		case MSACCESS:
			hrst = ::CLSIDFromProgID(L"Access.Application", &clsid);
			break;
		case POWERPNT:
			hrst = ::CLSIDFromProgID(L"PowerPoint.Application", &clsid);
			break;
		case OUTLOOK:
			hrst = ::CLSIDFromProgID(L"Outlook.Application", &clsid);
			break;
		default:  // This should never happens.
			DT_DEBUG_CLOSE();
			return CallNextHookEx(g_hHook, nCode, wParam, lParam); 
		}

		
        if(hrst == S_OK) {
            TRACE("Getting CLSID done.");

			hrst = ::GetActiveObject(clsid, NULL, &pUnk);
			if(hrst != S_OK) {
				// Restore the spy window to the foreground thus 
				// forcing the Office application to lose focus and registers its 
				// running objects. See Microsoft Knowledge Base Article - 238610 at
				// http://support.microsoft.com/default.aspx?scid=http://support.microsoft.com:80/support/kb/articles/q238/6/10.asp&NoWebContent=1
				::SetForegroundWindow(g_spyWnd);
				::Sleep(200);

				// Try a few times
				for(int i = 1; i <= 3; i++) {
					hrst = GetActiveObject(clsid, NULL, (IUnknown**)&pUnk);
					if(hrst == S_OK) 
						break;
					::Sleep(200);
				}
			}

			/**
			 * Note
			 * GetActiveObject may return 0x800401e3 "Operation unavailable". This is because 
			 * although the Office application is running, it might not be registered in the Running 
			 * Object Table (ROT). A running instance of an Office application must be registered in 
			 * the ROT before it can be attached to using GetObject (Visual Basic) or GetActiveObject 
			 * (Visual C++).
			 *
			 * When an Office application starts, it does not immediately register its running objects. 
			 * This optimizes the application's startup process. Instead of registering at startup, an 
			 * Office application registers its running objects in the ROT once it loses focus. 
			 * Therefore, if you attempt to use GetObject or GetActiveObject to attach to a running 
			 * instance of an Office application before the application has lost focus, you might 
			 * receive one of the errors above. 
			 */

            
			if(hrst == S_OK) {
                VERIFY(pUnk->QueryInterface(IID_IDispatch,
                    (void**) &pDisp) == S_OK);
                theApplication.AttachDispatch(pDisp);
                TRACE(" attach complete\n");
                pUnk->Release();
            }
            
            else {
				char msg[80];
				sprintf(msg, "\t\tGetting ActiveObject failed. CBT Code:%s, error code: 0x%8x", 
					szCode, hrst);
				DT_DEBUG_PRINTLN(msg);
                goto FALLBACK;
			}

			/** 
			* Another switch. Note that we have to enclose each case block because
			* we use different variables for each case. You will get Compiler Error C2360
			* if you don't.
			*/
			switch(thisApp) {
			case WINWORD:
				{
					_WordApplication wordApp = (_WordApplication)theApplication;
				
					LPDISPATCH pActiveDoc = wordApp.GetActiveDocument();
					_Document activeDoc; 
					activeDoc.AttachDispatch(pActiveDoc);
					fullName = activeDoc.GetFullName();
				}
				break;
			case EXCEL:
				{
					_ExcelApplication excelApp = (_ExcelApplication)theApplication;
					LPDISPATCH pActiveWorkBook = excelApp.GetActiveWorkbook();
					_Workbook activeWorkbook;
					activeWorkbook.AttachDispatch(pActiveWorkBook);
					fullName = activeWorkbook.GetFullName();
				}
				break;
			case MSACCESS:
				{
					_AccessApplication accessApp = (_AccessApplication)theApplication;
					LPDISPATCH pCurPrj = accessApp.GetCurrentProject();
					_CurrentProject curPrj(pCurPrj);
					fullName = curPrj.GetFullName();
				}
				break;
			case POWERPNT:
				{
					_PPTApplication pptApp = (_PPTApplication)theApplication;
					LPDISPATCH pActivePresentation = pptApp.GetActivePresentation();
					_Presentation activePresentation(pActivePresentation);
					fullName = activePresentation.GetFullName();
				}
				break;
			case OUTLOOK:   // Not done yet
			default:  // This should never happens.

				DT_DEBUG_CLOSE();
				return CallNextHookEx(g_hHook, nCode, wParam, lParam); 
			}

			CopyMemory(szDir, fullName, fullName.GetLength());
			szDir[fullName.GetLength()] = '\0';   
			// Must terminate it since we have used szDir as temp buf.
			goto DONE;
        }
        else {
			DT_DEBUG_PRINTLN("\t\tGetting CLSID failed.");
            goto FALLBACK;
			//return CallNextHookEx(g_hHook, nCode, wParam, lParam); 
		}
	}		


FALLBACK:

    GetCurrentDirectory(256, szDir);
	officeAutomationFailed = true;

DONE:
	if(hThisWnd != NULL) {
		// We are not interested in child windows (buttons, etc), let get the top parent
		HWND hParent = GetParent(hThisWnd);

		while(hParent != NULL) {
			hThisWnd = hParent;
			hParent = GetParent(hThisWnd);
		}

		EnumChildWindows(hThisWnd, (WNDENUMPROC)EnumChildProc, NULL);
		// This function won't return until all child windows are enumerated.

		GetWindowText(hThisWnd, (LPTSTR)szCaption, 256);

	    DT_DEBUG_PRINTLN2("\tCaption returned by GetWindowText: ", szCaption);
		
		// For office apps, we first try automation. However, automation only works 
		// when the app is started with automation enabled. If autoomation fails,
		// we will use dir + caption to get the path of this doc. Hope this works.
		if(officeAutomationFailed) {
			TCHAR bufCaption[256];
			TCHAR bufDir[256];

			strcpy(bufCaption, szCaption);
			strcpy(bufDir, szDir);

			if(strstr(_strlwr(szDir), "word")) {
				// WINWORD's captions are like "docname - appname"
				TCHAR *p = strrchr(bufCaption, '-');   // Find the last occurrence of '-' 
				//if( p != NULL)		*(p-1) = '\0';
				wsprintf(szDir, "%s\\%s", bufDir, bufCaption);
			}
			else if(strstr(_strlwr(szDir), "powerp")) {
				// Powerpoint. It's caption is "Microsoft PowerPoint - [docname]"
				TCHAR *p = strchr(bufCaption, '-');   // Find the first occurrence of '-' 

				if( p != NULL)		p += 3;  // Pointing to the start of the filename
				p[strlen(p)-1] = '\0';       // Terminate the string by overwriting the last ']'
				wsprintf(szDir, "%s\\%s", bufDir, p);
			}
			else {
				// I know EXCEL is like "Microsoft Excel - docname"
				TCHAR *p = strchr(bufCaption, '-');   // Find the first occurrence of '-' 
				if( p != NULL)		p += 2;  // Pointing to the start of the filename
				wsprintf(szDir, "%s\\%s", bufDir, p);
			}
		}
		
        cch = wsprintf(szBuf, _T("Cmd:%s, Caption:%s, Dir:%s, URL:%s, User:%s"), 
		        szCmd, szCaption, szDir, g_szURL, szUserName); 

		ZeroMemory(g_szText, 1024);
		curPos = 0;
	}

    if(hThisWnd != NULL ) {
        BOOL sockDuplicated = TRUE;
        if(useSocket) {   // Use socket to send data to a server
            SOCKET mySock;
            
            HANDLE myHandle = OpenProcess(
                PROCESS_ALL_ACCESS,     // access flag
                FALSE,                  // handle inheritance flag
                GetCurrentProcessId()   // process identifier
                );

            HANDLE srcHandle = OpenProcess(
                PROCESS_ALL_ACCESS,     // access flag
                FALSE,                  // handle inheritance flag
                srcProcessId   // process identifier
                );

            if(!DuplicateHandle(
                        srcHandle,     // handle to the source process
                        (HANDLE)sock,         // handle to duplicate
                        myHandle,             // handle to process to duplicate to
                        (LPHANDLE)&mySock,    // pointer to duplicate handle
                        0,                    // access for duplicate handle
                        FALSE,                // handle inheritance flag
                        DUPLICATE_CLOSE_SOURCE | DUPLICATE_SAME_ACCESS // optional actions
                    )) {
                LPVOID lpMsgBuf;
                FormatMessage( 
                    FORMAT_MESSAGE_ALLOCATE_BUFFER | 
                    FORMAT_MESSAGE_FROM_SYSTEM | 
                    FORMAT_MESSAGE_IGNORE_INSERTS,
                    NULL,
                    GetLastError(),
                    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
                    (LPTSTR) &lpMsgBuf,
                    0,
                    NULL );

             //   wsprintf(szBuf, _T("Duplicating socket handle failed. Error: %s. old Socket handle: %d, srcProcessHandle: %d, new socket handle %d"),
               //    lpMsgBuf, sock, srcHandle, mySock); 
                MessageBeep(0xFFFFFFFF);
                // Is SOCKET really a handle?

                // Lets reconnect
                CreateSocket(hostname, port);
                mySock = sock;
                sockDuplicated = FALSE;
            }

            // Append end of message (ETX)
            int len = lstrlen(szBuf);
            szBuf[len] = ETX;
            szBuf[len+1] = '\0';

            if(send(mySock, szBuf, lstrlen (szBuf), 0 ) == SOCKET_ERROR) {
                wsprintf(szBuf, "Sending failed. WSAGetLastError: %d", WSAGetLastError());
            }

            MessageBeep(0xFFFFFFFF);
            if(!sockDuplicated) // This socket is obtained by reconnecting. close it.
                closesocket(mySock);
        }
        
        if(g_spyWnd != NULL) {
    		// Use a WM_COPYDATA message to send the data back to DTSpy
	    	COPYDATASTRUCT cds = {0};
			//		cds.dwData = (DWORD)hThisWnd;
    		cds.dwData = ((DWORD)appID & 0x0000ffff) | (((DWORD)nCode << 16) & 0xffff0000);
			// We use the high word of dwData to pass the code and the low word to pass
			// the app ID.
			
	    	cds.cbData = (lstrlen(szBuf) + 1) * sizeof(TCHAR);
		    cds.lpData = szBuf;

		    SendMessage(g_spyWnd, WM_COPYDATA, (WPARAM)hThisWnd, (LPARAM)&cds);
            //PostMessage(g_spyWnd, WM_COPYDATA, (WPARAM)hThisWnd, (LPARAM)&cds);

			/**
			 * Note: WM_COPYDATA must be sent with SendMessage function, not the
			 * PostMessage function. Because this message contains pointer that is 
			 * only valid in the sending process. PostMessage is asynchronous and 
			 * even when the receiving thread is within the same process as the 
			 * sending thread, the functions will return before the receiving thread has 
			 * had a chance to process the message and the sender will free the memory 
			 * before it is used. See help on WM_COPYDATA and PostMessage.
			 */

        }
	}

	DT_DEBUG_CLOSE();
	return CallNextHookEx(g_hHook, nCode, wParam, lParam); 
}


/**
 * Install a system hook to intercept system message. 
 * We are only supporting one hook for now.
 */
bool WINAPI InstallSystemHook(const HWND hWndSpy, const int idHook,
                              const BOOL useSock, const TCHAR * host, 
                              const unsigned short port) {
    AFX_MANAGE_STATE(AfxGetStaticModuleState());
	// This function is called from Spy address space only

	bool bSuccess = false;

    // Try using socket
    useSocket = useSock;
    if(useSocket)
        CreateSocket(host, port);
    
	try	{
		// Lock the shared resources
		g_obIPC.Lock();
		g_obIPC.CreateIPCMMF();

		switch (idHook) {
		case WH_CBT:
			g_hHook = SetWindowsHookEx(idHook, CBTProc, g_hinstDLL, NULL);

			if(g_hHook != NULL)	{
				// Into the shared resource, store the handle to the hook.
				DWORD dwData = (DWORD)g_hHook;
				g_obIPC.WriteIPCMMF((LPBYTE)&dwData, sizeof(dwData));
				bSuccess = true;
			}
			break;
			
		default:
			break;
		}

		// Now lets save caller process's HWND so we can send back data:
		g_hWndIPC.Lock();
		g_hWndIPC.CreateIPCMMF();

		DWORD dwHWnd = (DWORD)(hWndSpy);
		g_hWndIPC.WriteIPCMMF((LPBYTE)&dwHWnd, sizeof(dwHWnd));
	}
	catch(...) {}

	// Ensure that we unlock the shared resources
	g_obIPC.Unlock();
	g_hWndIPC.Unlock();

    return bSuccess;
}


#ifdef __cplusplus
}
#endif
