#ifndef _MFCDT10_H
#define _MFCDT10_H

/**
 * This is the header file that contains the declaration of exported DLL 
 * functions. Client program should include this file. The file mfcditing.h
 * is for declaring class CMfcditingApp that is used to implement the DLL and
 * used only internally by the DLL code.
 */

#include <windows.h>   // For WINAPI

/////////////////////////////////////////////////////////////////////////////
// Exported DLL functions:

#define DITING_HOOK_DLL		_T("mfcditing.dll")

#ifdef DITINGHK_EXPORTS
#define DITINGHK_API __declspec(dllexport)
#else
#define DITINGHK_API __declspec(dllimport)
#endif


#ifdef __cplusplus
extern "C" {
#endif

// Exported functions called from Spy process
DITINGHK_API void WINAPI InitializeDiTingDLL();
DITINGHK_API bool WINAPI InstallSystemHook(const HWND hWndSpy, const int idHook,
                                           const BOOL useSock, const TCHAR * host, 
                                           const unsigned short port);
DITINGHK_API int WINAPI RegisterApp(const TCHAR * cmd, bool needURL);
DITINGHK_API int IsRegistered(const TCHAR * cmd);
DITINGHK_API bool WINAPI UnRegisterApp(const TCHAR * cmd);
DITINGHK_API bool WINAPI RemoveHook();

// Data structures exported:
#ifndef MAX_PATH
#define MAX_PATH 256
#endif

typedef struct {
	TCHAR cmd[MAX_PATH];           // Command line
	TCHAR currentDir[MAX_PATH];
	BOOL needURL; 
	// Retrieve URL from child window text or not.

	// other info?
} AppInfo;

// Constants defined for this DLL:
#define MAX_REGISTERED_APPS   128
#define ID_NOTREGISTERED      0xffff
// Will return this as app ID if we see an app that is not registed with us
// Note that we are not using -1 here because it will be embedded in the low
// word of dwData in COPYDATASTRUCT and will be retrieved by LOWORD macro. 
// The receiver won't get -1 if it sees 0xffff (which is what -1 looks like in
// 16 bits) and casts it to int. 


// Functions called from the hooked process
LRESULT WINAPI CBTProc(int nCode, WPARAM wParam, LPARAM lParam);


#ifdef __cplusplus
}
#endif

#endif